( function( $ ) {

    "use strict";

    function isTouchEnabled() {
    return (('ontouchstart' in window)
        || (navigator.MaxTouchPoints > 0)
        || (navigator.msMaxTouchPoints > 0));
    }

    $(document).ready(function () {
        $("path[id^=\"usmapvt_\"]").each(function (i, e) {
            addEvent($(e).attr('id'));
        });
    });

    function addEvent(id, relationId) {
        var _obj = $('#' + id);
        var _Textobj = $('#' + id + ',' + '#' + us_map_t_config[id]['title']);
        $('#usmapwrapper-t').css({'opacity': '1'});

        if(us_map_t_config['default']['usshowvisns_t'] === true) {
            $('#usvisns-t').css({'fill': us_map_t_config['default']['usvisns_t']});
            $('#usvisns-t').css({'opacity': '1'});
        } else {
            $('#usvisns-t').css({'opacity': '0'});
        }

        if(us_map_t_config['default']['usshowlakes_t'] === true) {
            $('#uslakes-t path').css({'stroke': us_map_t_config['default']['usbrdrclr_t']});
            $('#uslakes-t').css({'fill': us_map_t_config['default']['uslakesfill_t']});
            $('#uslakes-t').css({'visibility': 'visible'});
        } else {
            $('#uslakes-t').css({'visibility': 'hidden'});
        }

        if(us_map_t_config['default']['usshowalaska_t'] === true) {
            $('#usmapvt_2' + ',' + '#usvnvt_2').css({'visibility': 'visible'});
        } else {
            $('#usmapvt_2' + ',' + '#usvnvt_2').css({'visibility': 'hidden'});
        }

        if(us_map_t_config['default']['usshowhawaii_t'] === true) {
            $('#usmapvt_11' + ',' + '#usvnvt_11').css({'visibility': 'visible'});
        } else {
            $('#usmapvt_11' + ',' + '#usvnvt_11').css({'visibility': 'hidden'});
        }

        if(us_map_t_config['default']['usshowdc_t'] === true) {
            $('#usmap_dc' + ',' + '#usvn_dc').css({'visibility': 'visible'});
        } else {
            $('#usmap_dc' + ',' + '#usvn_dc').css({'visibility': 'hidden'});
        }

        if(us_map_t_config['default']['uscallouts_t'] === true) {
            $('#uscallouts-t').css({'visibility': 'hidden'});
        } else {
            $('#uscallouts-t').css({'visibility': 'visible'});
        }

        _obj.attr({'fill': us_map_t_config[id]['upclr'], 'stroke': us_map_t_config['default']['usbrdrclr_t']});

        _Textobj.attr({'cursor': 'default'});

        if (us_map_t_config[id]['enbl'] === true) {
            if (isTouchEnabled()) {
                var touchmoved;
                _Textobj.on('touchend', function (e) {
                    if (touchmoved !== true) {
                        _Textobj.on('touchstart', function (e) {
                            let touch = e.originalEvent.touches[0];
                            let x = touch.pageX - 10, y = touch.pageY + (-15);

                            let $usmtip = $('#tipusmap-t');
                            let usmaptipw = $usmtip.outerWidth(),
                                usmaptiph = $usmtip.outerHeight();

                            x = (x + usmaptipw > $(document).scrollLeft() + $(window).width()) ? x - usmaptipw - (20 * 2) : x
                            y = (y + usmaptiph > $(document).scrollTop() + $(window).height()) ? $(document).scrollTop() + $(window).height() - usmaptiph - 10 : y

                            if (us_map_t_config[id]['targt'] !== 'none') {
                                _obj.css({'fill': us_map_t_config[id]['dwnclr']});
                            }
                            $usmtip.show().html(us_map_t_config[id]['hover']);
                            $usmtip.css({left: x, top: y})
                        })
                        _Textobj.on('touchend', function () {
                            _obj.css({'fill': us_map_t_config[id]['upclr']});
                            if (us_map_t_config[id]['targt'] === '_blank') {
                                window.open(us_map_t_config[id]['url']);
                            } else if (us_map_t_config[id]['targt'] === '_self') {
                                window.parent.location.href = us_map_t_config[id]['url'];
                            }
                            $('#tipusmap-t').hide();
                        })
                    }
                }).on('touchmove', function (e) {
                    touchmoved = true;
                }).on('touchstart', function () {
                    touchmoved = false;
                });
            }
            _Textobj.attr({'cursor': 'pointer'});

            _Textobj.on('mouseenter', function () {
                $('#tipusmap-t').show().html(us_map_t_config[id]['hover']);
                _obj.css({'fill': us_map_t_config[id]['ovrclr']})
            }).on('mouseleave', function () {
                $('#tipusmap-t').hide();
                _obj.css({'fill': us_map_t_config[id]['upclr']});
            })
            if (us_map_t_config[id]['targt'] !== 'none') {
                _Textobj.on('mousedown', function () {
                    _obj.css({'fill': us_map_t_config[id]['dwnclr']});
                })
            }
            _Textobj.on('mouseup', function () {
                _obj.css({'fill': us_map_t_config[id]['ovrclr']});
                if (us_map_t_config[id]['targt'] === '_blank') {
                    window.open(us_map_t_config[id]['url']);
                } else if (us_map_t_config[id]['targt'] === '_self') {
                    window.parent.location.href = us_map_t_config[id]['url'];
                }
            })
            _Textobj.on('mousemove', function (e) {
                let x = e.pageX + 10, y = e.pageY + 15;

                let $mus = $('#tipusmap-t');
                let usmaptipw = $mus.outerWidth(), usmaptiph = $mus.outerHeight();

                x = (x + usmaptipw > $(document).scrollLeft() +
                    $(window).width()) ? x - usmaptipw - (20 * 2) : x
                y = (y + usmaptiph > $(document).scrollTop() + $(window).height()) ?
                    $(document).scrollTop() + $(window).height() - usmaptiph - 10 : y

                $mus.css({left: x, top: y})
            })
        }
    }
})(jQuery);
